---
title: HMDVRDevice.setFieldOfView()
slug: Web/API/HMDVRDevice/setFieldOfView
tags:
  - API
  - Experimental
  - Expérimental(2)
  - HMDVRDevice
  - Method
  - Obsolete
  - Reference
  - Référence(2)
  - VR
  - Virtual Reality
  - WebVR
---
<div>{{obsolete_header()}}{{APIRef("WebVR API")}}{{SeeCompatTable}}</div>

<p>The <strong><code>setFieldOfView()</code></strong> method of the {{domxref("HMDVRDevice")}} interface can be used to set the field of view for one eye, or both eyes simultaneously.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">HMDVRDevice.setFieldOfView(leftFOV,rightFOV,zNear,zFar);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>leftFOV {{optional_inline}}</code></dt>
 <dd>A <code>{{domxref("VRFieldOfView")}}</code> object that defines the new field of view for the left eye. If not specified, the left eye field of view does not change.</dd>
 <dt><code>rightFOV {{optional_inline}}</code></dt>
 <dd>A <code>{{domxref("VRFieldOfView")}}</code> object that defines the new field of view for the right eye. If not specified, the right eye field of view does not change.</dd>
 <dt><code>zNear {{optional_inline}}</code></dt>
 <dd>The distance from the eyes of the nearest point of the view. The closest things can be and still be in the view. If not specified, the default is used — <code>0.01</code>.</dd>
 <dt><code>zFar {{optional_inline}}</code></dt>
 <dd>The distance from the eyes of the farthest point of the view. The furthest away things can be and still be in the view. If not specified, the default is used — <code>10000.0</code>.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>Void.</p>

<h2 id="Examples">Examples</h2>

<p>The following simple example shows a function that can be used to set a custom field of view with four specified degree values for up, right, down and left. The {{domxref("VRFieldOfView.VRFieldOfView","VRFieldOfView()")}} constructor is used to create a {{domxref("VRFieldOfView")}} object from the supplied values, which is then fed into the <code>setFieldOfView()</code> method (the default <code>zNear</code> and <code>zFar</code> values are always used, in this case.)</p>

<pre class="brush: js">function setCustomFOV(up,right,down,left) {
  var testFOV = new VRFieldOfView(up,right,down,left);

  gHMD.setFieldOfView(testFOV,testFOV,0.01,10000.0);

  var lEye = gHMD.getEyeParameters('left');
  var rEye = gHMD.getEyeParameters('right');
  console.log(lEye.currentFieldOfView);
  console.log(rEye.currentFieldOfView);
}</pre>

<div class="note">
<p><strong>Note</strong>: When testing, setting a weird/tiny field of view can really mess up your view. It is a good idea to grab the current field of view first (using {{domxref("VREyeParameters.currentFieldOfView")}}) before making any drastic changes, so you can reset it afterwards if needed.</p>
</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HMDVRDevice.setFieldOfView")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVR_API">WebVR API homepage</a>.</li>
 <li><a href="http://mozvr.com/">MozVr.com</a> — demos, downloads, and other resources from the Mozilla VR team.</li>
</ul>
